import os

from si_tests import settings
from . import file_utils
from si_tests import logger

LOG = logger.logger


class ExtraContext:
    def __init__(self):
        context_file = settings.OPENSTACK_DEPLOY_EXTRA_CONTEXT_FILE

        if os.path.exists(context_file):
            self._data = file_utils.get_yaml_content(context_file) or {}
            LOG.info(f"Extra context updated from {context_file}")
        else:
            self._data = {}
            LOG.info("Extra context is empty")

    @property
    def data(self):
        return self._data

    @property
    def third_party(self):
        return self.data.get("3rd-party", {})

    @property
    def metallb(self):
        return self.third_party.get("metallb", {})

    @property
    def ceph(self):
        return self.third_party.get("ceph", {})

    @property
    def openstack_cluster(self):
        return self.data.get("openstack", {})

    @property
    def openstack_controller(self):
        return self.data.get("operator", {})

    @property
    def tf_helm(self):
        return self.data.get("tf-helm", {})

    @property
    def tf_operator(self):
        return self.data.get("tf-operator", {})

    @property
    def openstack_opts(self):
        return self.data.get("openstack_opts", {})
